VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTimmer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Note: This is not to fire an action each time an interval passes
'This timmer control is for benchmark testing. Tracks the amount of time for an action to occure.

Private StartTime                                       As Double  'variable to hold the tickcount when the timmer is started
Private EndTime                                         As Double  'variable to hold the tickcount when timmer is stoped
Private Declare Function GetTickCount Lib "kernel32" () As Long    'get tick count API

Public Property Get TimeSpent() As String
    EndTime = GetTickCount                                         'set the count passed in milliseconds
    TimeSpent = FormatCount(EndTime - StartTime, 1)                'call a function to format the time spent
End Property
'the following property allowed me to format any number passed as time
'Public Property Get tFormat(Count As Double, Optional FormatType As Byte = 0) As String
'    tFormat = FormatCount(Count, FormatType)
'End Property

Public Sub TStart()
    StartTime = GetTickCount                                       'get the starting time
End Sub

Private Function FormatCount(Count As Double, Optional FormatType As Byte = 0) As String
    Dim Days As Integer, Hours As Long, Minutes As Long, Seconds As Double, Miliseconds As Double
    Miliseconds = Count Mod 1000                                   'remove seconds and milliseconds are left
    Count = Count \ 1000                                           'set count = to the number of seconds
    Days = Count \ (24& * 3600&)                                   'multiply the number of seconds in an hour by the number of hours in a day devide that into the number of seconds is the number of days
        If Days > 0 Then Count = Count - (24& * 3600& * Days)      'remove the number of days in seconds from the total number of seconds
    Hours = Count \ 3600&                                          'Devide the number of seconds in an hour into the number of seconds left after days were removed is the number of hours
        If Hours > 0 Then Count = Count - (3600& * Hours)          'remove the number of hours in seconds from the number of seconds left after the days are removed
    Minutes = Count \ 60                                           'devide the number of seconds left after hours are removed by 60 is the number of minits
    Seconds = Count Mod 60                                         'the remainder of the number of seconds left after hours are removed will be the seconds
    Select Case FormatType                                         'Basically the lines bellow control how the formated time is displayed to the user change to suit your needs
        Case 0
            FormatCount = Days & " dd, " & Hours & " h, " & _
            Minutes & " min, " & Seconds & " s, " & Miliseconds & _
            " ms"
        Case 1
            FormatCount = Days & " days, " & Hours & " hours, " & _
            Minutes & " minutes, " & Seconds & " seconds, " & Miliseconds & _
            " miliseconds"
        Case 2
            FormatCount = Days & ":" & Hours & ":" & _
            Minutes & ":" & Seconds & ":" & Miliseconds
    End Select
End Function
